var WebTag = {

  logged_in: false,

  onLoad: function() {
    var appcontent = document.getElementById("appcontent");
    if(appcontent) {
      appcontent.addEventListener("load", WebTag.onPageLoad, true);
    }

    // localization strings
    var strings = document.getElementById("webtag_bundle");

    WebTag.s_please_login =             strings.getString('webtag_please_login');
    WebTag.s_found_a_tag =              strings.getString('webtag_found_a_tag');
    WebTag.s_login_server_unavailable = strings.getString('webtag_login_server_unavailable');
    WebTag.s_login_error =              strings.getString('webtag_login_error');
    WebTag.s_login_more_info =          strings.getString('webtag_login_more_info');
//    WebTag.s_ = strings.getString('webtag_');

    WebTag.checkLogin(function(){});

  },

  onPageLoad: function(aEvent) {
    if (WebTag.isEnabled() &&                            // only check if we are enabled
	aEvent.originalTarget.nodeName == "#document") { // and we have an actual page to check
      WebTag.checkPage(aEvent.originalTarget.location.href);
    }
  },

  isEnabled: function() {
    return document.getElementById("webtag_enabled").getAttribute("checked");
  },

  onToolbarButtonClick: function(event) {
    switch(event.button) {
      case 0:
        // Left click
        // Try to place a tag on the currently view page
        WebTag.tagPage(WebTag.getURL());
        break;
      case 1:
        // Middle click, nothing for now
        break;
      case 2:
        // Right click, nothing for now
        break;
    }
  },

  tagPage: function(href) {
    if (WebTag.logged_in) {
      var func = function(event) {
	alert(event.target.responseText);
      }
      WebTag.makePOSTReq('', 'f=place_tag&href=' + escape(href), func);
    } else {
      WebTag.checkLogin(function(){WebTag.tagPage(href);});
    }
  },

  checkLogin: function(doIfLoggedIn) {
      var lfunc = function(event) {
	if (event.target.responseText == '1') {
	  WebTag.logged_in = true;
	  document.getElementById("webtag_enabled").setAttribute("checked", true);
	  doIfLoggedIn();
	} else {
	  alert(WebTag.s_please_login);
	}
      }
      WebTag.makeGETReq('?is_logged_in', lfunc);
  },

  getURL: function() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
    getService(Components.interfaces.nsIWindowMediator);
    var recentWindow = wm.getMostRecentWindow("navigator:browser");
    return recentWindow ? recentWindow.content.document.location : null;
  },

  checkPage: function(href) {
    var func = function(event) {
      var parts = event.target.responseText.split("|");
//      alert(parts[0]);
      if (parts[0] == "1") {
	// the've found a tag
	alert(WebTag.s_found_a_tag);
      } else if (parts[0] == "Only http pages are allowed.") {
	// This message can be ignored on checks
	return;
      } else if (parts[0] != "0") {
	// Some other message TODO: make this message localizable via a *.properties file
//	alert(parts[0]);
      }
    }

    if (href.substr(0, 7) == "http://") {
      WebTag.makeGETReq('?check&href=' + escape(href), func);
    }
  },

  makeGETReq: function(args, func) {
    var req = new XMLHttpRequest();
    req.open('GET', 'http://mmatton.dyndns.org/~webtag/ext.php' + args, true);
    req.onload = func;
    req.send(null);
  },

  makePOSTReq: function(getargs, data, func) {
    var req = new XMLHttpRequest();
    req.open('POST', 'http://mmatton.dyndns.org/~webtag/ext.php' + getargs, true);
    req.onload = func;
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.send(data);
  },

  toggleOn: function() {
    if (!WebTag.logged_in && WebTag.isEnabled()) {
      var w = window.open("chrome://webtag/content/login.xul", "", "chrome");
    }
  },

  login: function(param) {
    var name = document.getElementById("webtag_name");
    var pass = document.getElementById("webtag_pass");
    if (name.value == "" || pass.value == "") {
      document.getElementById("webtag_login_feedback").value = WebTag.s_login_more_info;
      return false;
    }
    var req = new XMLHttpRequest();
    req.open('POST', 'http://mmatton.dyndns.org/~webtag/ext.php', false);
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.send("login=login&n=" + escape(name.value) + "&p=" + escape(pass.value));

    if (req.status == 200) {
      if (req.responseText == "1") {
	pass.value = ""; // blank this out since I'm not sure whether it survives or not
	WebTag.logged_in = true;
	alert("logged in");
	return true;
      } else {
	if (req.responseText) {alert(req.responseText);}
	alert(WebTag.s_login_error);
	document.getElementById("webtag_login_feedback").value = WebTag.s_login_error;
	return false;
      }
    } else {
      document.getElementById("webtag_login_feedback").value = WebTag.s_login_server_unavailable;
      return false;
    }

    return false;
  }
};

window.addEventListener("load", function(e) { WebTag.onLoad(e); }, false);
